<template>
  <ChatToolbarHeader
    :name="chatData.information.name"
    :avatar="gettingImage"
    :dirIsLtr="languageIsEnglish"
    :avatarClass="chatData.information.avatarClass"
    :isMySelf="chatData.isMySelf"
    :selectingChatIsActive="selectingChatIsActive"
    :selectedChatCount="getSelectedChatCount"
    @makeVoiceCall="makeVoiceCall"
    @makeVideoCall="makeVideoCall"
    @openProfileModal="openContactProfileModal"
    @resetSelectingChat="resetSelectingChat"
    @onCopy="setCopyToClipboard('collectionOfMessage')"
    @onForward="openFordadedMessage"
  >
  </ChatToolbarHeader>
  <Loading v-if="showLoading"></Loading>
  <IonContent
    class="messages-container"
    :class="{ 'opacity-0': !showChatItem }"
    color="bg-chat"
    ref="scrollArea"
  >
    <MessageCard
      v-for="chatItem in getChatList"
      :key="'chat-oto-' + chatItem.id"
      :messageData="chatItem"
      :name="chatData.information.name"
      :isSelected="selectedChatItems[chatItem.id] ? true : false"
      :isSelectState="selectingChatIsActive"
      @click.self="setSelectedItems(chatItem)"
      @setSelectedItems="setSelectedItems"
      @onReply="replayMessageHandler"
      @onForward="forwardMessageHandler"
      @onScrollToTargetChat="scrollToTargetChat"
      @onCopy="setCopyToClipboard"
      :id="`chat-oto-ref-${chatItem.id}`"
    ></MessageCard>
  </IonContent>
  <ChatInput
    chatType="oto"
    :replayMessageInfo="replayMessageInfo"
    @sendMessage="sendMessage"
    @edit="editMessage"
    @replay="replayMessage"
    @sendVoice="sendVoiceAudio"
    @closeManipulationContainer="replayMessageInfo = null"
  ></ChatInput>
</template>
<script setup>
import { IonContent, modalController } from '@ionic/vue';
import {
  ref,
  computed,
  defineProps,
  onMounted,
  onUnmounted,
  nextTick,
} from 'vue';
import { useI18n } from 'vue-i18n';
import { useCallStore } from '@/store/call/call.js';
import { useOtoStore } from '@/store/chats/otoChat.js';
import { useContactsStore } from '@/store/contacts/contacts.js';
import { useFileManagerStore } from '@/store/fileManager/fileManager.js';
import ChatToolbarHeader from '@/components/message/OTO/ChatToolbarHeader.vue';
import MessageCard from '@/components/message/basics/MessageCard/index.vue';
import ChatInput from '@/components/message/basics/ChatInput/index.vue';
import ProfileContactModal from '@/components/contacts/profile/index.vue';
import ForwardedModal from '@/components/message/basics/Forward/index.vue';
import Loading from '@/components/message/basics/loading.vue';
import { useVideoCallStore } from '@/store/videoCall/videoCall';
import { copyToClipboard } from '@/helpers/browserApis.js';
const showChatItem = ref(false);

const languageIsEnglish = computed(() => {
  const { locale } = useI18n();
  return locale.value == 'en';
});
const props = defineProps({
  chatData: {
    type: Object,
    default: () => {},
  },
});
const showLoading = computed(() => {
  const OTOStore = useOtoStore();
  return OTOStore.showLoading || !showChatItem.value;
});
const getChatList = computed(() => {
  const OTOStore = useOtoStore();
  return OTOStore.getCurrentChat;
});
const gettingImage = computed(() => {
  const fileManagerStore = useFileManagerStore();
  const profile =
    fileManagerStore.usersAvatarBlobList[
      props.chatData.information.avatarFileId
    ];
  if (profile && profile.thumbnailFile) {
    return profile.thumbnailFile;
  }
  return false;
});
const getSelectedChatCount = computed(() => {
  return Object.keys(selectedChatItems.value).length || 0;
});
const sendMessage = (data) => {
  const OTOStore = useOtoStore();
  if (
    props.chatData.information.source ||
    props.chatData.information.wch_nickname
  ) {
    data['webChatData'] = {
      wch_nickname: props.chatData.information.name,
    };
  }
  OTOStore.send(data, scrollToBottom);
};
const editMessage = (data) => {};
const replayMessage = (data) => {};

const sendVoiceAudio = (data) => {
  const OTOStore = useOtoStore();

  OTOStore.send(
    {
      files: [data],
    },
    scrollToBottom,
  );
};
const replayMessageInfo = ref();
const replayMessageHandler = (messageData) => {
  replayMessageInfo.value = {
    ...messageData,
    name: props.chatData.information.name,
  };
};
const forwardMessageHandler = (messageData) => {
  console.log(messageData, 'on message data forwrded');
};
const makeVoiceCall = async () => {
  const contactStore = useContactsStore();
  const result = await contactStore.getContactInformation(
    props.chatData.chatId,
  );
  const phoneNumber = result.phone_number || result.contact_phone;
  if (!phoneNumber) return;
  const callStore = useCallStore();
  callStore.makeFreeCall(phoneNumber);
};
const makeVideoCall = () => {
  const OTOStore = useOtoStore();
  const { currentChatId } = OTOStore;
  const videoCallStore = useVideoCallStore();
  videoCallStore.makeConferenceInOTO(currentChatId);
};
const selectedChatItems = ref({});
const selectingChatIsActive = ref(false);
const setSelectedItems = (chatItem) => {
  selectingChatIsActive.value = true;
  const targetId = chatItem.id;
  if (selectedChatItems.value[targetId]) {
    delete selectedChatItems.value[targetId];
  } else {
    selectedChatItems.value[targetId] = chatItem;
  }
};
const resetSelectingChat = () => {
  selectingChatIsActive.value = false;
  selectedChatItems.value = {};
};
const setCopyToClipboard = (messageData) => {
  if (messageData?.type == 'text') {
    copyToClipboard(messageData.content);
  }
  if (messageData == 'collectionOfMessage') {
    const selectedMessagesData = Object.values(selectedChatItems.value);
    let text = '';
    selectedMessagesData.forEach((chatData) => {
      if (chatData.type == 'text') {
        text += chatData.content + '\n';
      }
    });
    copyToClipboard(text);
  }
  resetSelectingChat();
};
const scrollToTargetChat = (refId) => {
  const targetElement = scrollArea.value.$el.querySelector(
    `#chat-oto-ref-${refId}`,
  );
  if (targetElement) {
    targetElement.scrollIntoView({
      behavior: 'smooth',
      alignToCenter: true,
    });
  }
};
const openContactProfileModal = () => {
  requestAnimationFrame(async () => {
    const modal = await modalController.create({
      component: ProfileContactModal,
      componentProps: {
        userId: props.chatData.chatId,
        name: props.chatData.information.name,
        avatarBackColor: props.chatData.information.avatarClass,
        phoneNumber: props.chatData.information.phoneNumber,
      },
    });

    modal.present();
  });
};
const openFordadedMessage = () => {
  console.log(selectedChatItems, 'jijojo');
  requestAnimationFrame(async () => {
    const modal = await modalController.create({
      component: ForwardedModal,
      componentProps: {
        messages: selectedChatItems.value,
      },
    });

    modal.present();
  });
};
const scrollArea = ref(null);
const scrollToBottom = (duration = 1000) => {
  if (scrollArea.value) {
    return scrollArea.value.$el.scrollToBottom(duration);
  }
  return Promise.reject(false);
};

onMounted(() => {
  const OTOStore = useOtoStore();
  const chatData = props.chatData;
  OTOStore.currentChatId = chatData.chatId;
  if (getChatList.value && getChatList.value.length) {
    setTimeout(() => {
      nextTick(() => {
        requestAnimationFrame(() => {
          scrollToBottom(0).then(() => {
            showChatItem.value = true;
            // openFordadedMessage();
          });
        });
      });
    }, 100);
  }
  OTOStore.setScrollerFucntion(scrollToBottom);

  if (!chatData.lastMessageData.guid && !chatData.lastSeenData.guid) {
    return;
  }
  if (!chatData.isFromMe) {
    OTOStore.sendSeenRequestOfMessage(
      chatData.chatId,
      chatData.lastMessageData.guid,
    );
  }
  OTOStore.handlerForGettingMessages(
    chatData.chatId,
    chatData.lastMessageData.guid,
    chatData.lastSeenData.guid,
    chatData.information.source,
  ).then(() => {
    setTimeout(() => {
      nextTick(() => {
        requestAnimationFrame(() => {
          scrollToBottom(0).finally(() => {
            showChatItem.value = true;
          });
        });
      });
    }, 100);
  });
});

onUnmounted(() => {
  const OTOStore = useOtoStore();
  OTOStore.currentChatId = '';
});
</script>
